'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MarkovChain = function () {
  function MarkovChain(list) {
    _classCallCheck(this, MarkovChain);

    this._chain = {};

    this.lastItem = undefined;
    this._build(list);
  }

  _createClass(MarkovChain, [{
    key: '_build',
    value: function _build(list) {
      var _this = this;

      list.forEach(function (item, index) {
        if (index === 0 && typeof _this.lastItem !== 'undefined') {
          _this._appendItem(_this.lastItem, item);
        }

        if (index !== list.length - 1) {
          var nextItem = list[index + 1];
          _this._appendItem(item, nextItem);
        } else {
          _this.lastItem = list[index];
        }
      });
    }
  }, {
    key: '_appendItem',
    value: function _appendItem(item, nextItem) {
      if (!(item in this._chain)) {
        this._chain[item] = [nextItem];
      } else {
        this._chain[item].push(nextItem);
      }
    }
  }, {
    key: '_clearChain',
    value: function _clearChain() {
      this._chain = {};
    }
  }, {
    key: 'appendItems',
    value: function appendItems(list) {
      this._build(list);
    }
  }, {
    key: '_getStartingItem',
    value: function _getStartingItem() {
      var allObjects = Object.keys(this._chain);
      return allObjects[Math.floor(Math.random() * allObjects.length)];
    }
  }, {
    key: '_getRandomItem',
    value: function _getRandomItem(item) {
      var successiveItems = this._chain[item];
      if (successiveItems.length > 0) {
        return successiveItems[Math.floor(Math.random() * successiveItems.length)];
      }
      return this._getStartingItem();
    }
  }, {
    key: 'generate',
    value: function generate(sequenceLength) {
      var startingWord = this._getStartingItem();
      var items = [startingWord];
      var index = 1;

      while (items.length < sequenceLength) {
        var lastItem = items[items.length - 1];
        items.push(this._getRandomItem(lastItem));
      }

      return items;
    }
  }]);

  return MarkovChain;
}();

exports.default = MarkovChain;